/**
 *  Experiment
 *  Author: Mahefa
 *  Description: 
 */

model Experiment

/* Insert your model definition here */

import "Globals.gaml"
import "Experiment.gaml"
import "House.gaml"
import "Inhabitant.gaml"
import "Plot.gaml"
import "river.gaml"
import "road.gaml"
import "SuperAgent.gaml"
import "Water.gaml"

experiment simulation2D type: gui {
   parameter "Shapefile for the buildings:" var: shape_file_buildings category: "GIS" ;
   parameter "Information of Inhabitant:" var: Inhabitant_informed <- false category: "Parameters"  ;
   parameter "Runaway:" var: runaway <- false category: "Parameters"  ;
   output {
   display city_display { // type:opengl 
   	  
      species river aspect: base ;
      species House aspect: base ;
      species Inhabitant aspect: base ;
     // species road aspect: base ;
      species Water aspect: base transparency: 1;
      grid Plot triangulation:true draw_as_dem:true transparency:0.5; 
   }
   
   display nb_people{
			chart "number of death and rescued" type: series {								
				data "#rescued" value: nb_rescued color: #blue; 
				data "#death" value: nb_death color: #red; 				 
			}
		}  
}
}


experiment simulation3D type: gui {
   parameter "Shapefile for the buildings:" var: shape_file_buildings category: "GIS" ;
   parameter "Information of Inhabitant:" var: Inhabitant_informed <- false category: "Parameters"  ;
   parameter "Runaway:" var: runaway <- false category: "Parameters"  ;
   
   output {
   display city_display type:opengl { // type:opengl 
   	  
      species river aspect: base ;
      species House aspect: base ;
      species Inhabitant aspect: threeD ;
     // species road aspect: base ;
      species Water aspect: base transparency: 1;
      grid Plot triangulation:true draw_as_dem:true transparency:0.5; // draw_as_dem: true
   }
   
   display nb_people{
			chart "number of death and rescued" type: series {								
				data "#rescued" value: nb_rescued color: #blue; 
				data "#death" value: nb_death color: #red; 				 
			}
		}  
}
}