/**
 *  Globals
 *  Author: Mahefa
 *  Description: 
 */

model Globals

/* Insert your model definition here */

import "Experiment.gaml"
import "House.gaml"
import "Inhabitant.gaml"
import "Plot.gaml"
import "river.gaml"
import "road.gaml"
import "SuperAgent.gaml"
import "Water.gaml"

global {
	
	// Importation des données spatials GIS
	
   file shape_file_buildings <- file("../includes/Village13_VIE.shp");
   file shape_file_roads <- file("../includes/routes_38S.shp"); 
   file shape_file_river <- file("../includes/river_38S.shp"); 
   file mnt <- file("../includes/mnt.asc");
   file shape_file_bounds <- file("../includes/bound_13.shp");
   geometry shape <- envelope(shape_file_bounds);

   float Unit_Water_Level <- 1.0; 
//   float step <- 10 #mn;

// Les variables 
   int nb_death <- 0;
   int nb_rescued <- 0 ;
   bool Inhabitant_informed <- false ;
   bool runaway <- false ;
   int inhabitant_perception <- 3 ;
  init {
  	
   create House from: shape_file_buildings  { 
	   color <- #black ;  
	   float z <-(Plot(location)).grid_value;
	   location <- {location.x,location.y,z};     
   }
   
   
   create road from: shape_file_roads with: [type::string(read("Name"))] {
         color <- #black ;
   }
   
   create river from: shape_file_river  {
         color <- #gray ;
   }
   
   ask river {
   	
   	list<Plot> temp <- Plot where (each intersects self );
   ask temp {
   	color <- # blue ;
   	isriver <- true ;
   }
   
   } 
  
  }
  
  reflex flowing {
  	
	  	ask Plot {
	  		do startFlowing ;
	  	}
	  	ask Water { 
	  		do move ;
	  	}
	  	ask Plot {
	  		do to_color_flood; 
	  	}	
  }
  }