/**
 *  Inhabitant
 *  Author: Mahefa
 *  Description: 
 */

model Inhabitant

/* Insert your model definition here */

import "Globals.gaml"
import "Experiment.gaml"
import "House.gaml"
import "Inhabitant.gaml"
import "Plot.gaml"
import "river.gaml"
import "road.gaml"
import "SuperAgent.gaml"
import "Water.gaml"

species Inhabitant  parent:Superagent skills: [moving]  {	
	House myHouse ;
	float speed <- 10 #m/#s;
	// int perception <- 3;
	rgb color ;
	init {
		// myPlot <- one_of(Plot);
		// location <- myPlot.location ;
		myPlot <- one_of(Plot where (each intersects self));
	}
	
	aspect threeD {
		color <- #yellow ;
		float size <- 3.0 ;
		draw pyramid(size) at: {location.x,location.y,myPlot.altitude} color: color;
		draw sphere(size/3) at: {location.x,location.y,myPlot.altitude + size} color: color ;
	}
	aspect base {
		color <- #yellow ;
		float size <- 3.0 ;
		 draw circle(size) color:color;	
	}

action run_away_from_flood {
	
		// Plot targetPlot <- myPlot ;
		
		loop onePlot over: myPlot.plotPerceived {
			if onePlot.isflooded = false {
				do goto target: onePlot ;
			}
		}
		
	
	
}

// Le comportement du villageois qui as les deux traits "informed" et "running away"
// en même temps est très intéressant à observer
	reflex walk {	
		if runaway = true {
			do run_away_from_flood ;
		}
		
		if Inhabitant_informed = true 
		{
		   do goto target:one_of(Plot where (each.issafetypoint = true));    
		}
		
		if runaway = false and Inhabitant_informed = false {
			do wander ; // do move ; 
		  }
		 
		myPlot <- one_of(Plot where (each intersects self));
		
		if myPlot.isflooded = true { 
			color <- #red ;
			nb_death <- nb_death + 1 ;
			myHouse.color <- #red ;
			do die ;
		}
		
		if myPlot.issafetypoint = true and myPlot.isflooded = false {
			
			nb_rescued <- nb_rescued + 1 ;
			myHouse.color <- #green ;
			do die ;
		}
		
	}
	}
