/**
 *  Plot
 *  Author: Mahefa
 *  Description: 
 */

model Plot

/* Insert your model definition here */

import "Globals.gaml"
import "Experiment.gaml"
import "House.gaml"
import "Inhabitant.gaml"
import "Plot.gaml"
import "river.gaml"
import "road.gaml"
import "SuperAgent.gaml"
import "Water.gaml"

grid Plot file: mnt  neighbours: 8 {
      rgb color <- grid_value = -9999 ? rgb('black') :  rgb(255 * ( grid_value / 100 ), 0, 0) ;
      float altitude <- grid_value ;
      bool isriver <- false;
      bool issafetypoint <- false;
      bool isflooded <- false;
      float waterLevel ;
      list<Plot> neighbours <- self neighbours_at 1;
      list<Plot> plotPerceived <- self neighbours_at inhabitant_perception;
      
      init {
      	if (grid_x > 25 and grid_y > 25 and altitude > 23) {
      		color <- #green ;
      		issafetypoint <- true ;
      	}
      }
      
      
      action startFlowing { 
      	if isriver = true {
      		do init_flood ;
      	}
      }
      
      action init_flood {     
        	create Water number:1 {
        		 myPlot <- myself ;
        		 location <- (myPlot.location) ;
        		 myself.waterLevel <- myself.waterLevel + Unit_Water_Level;
        	}	
        }
      
      action to_color_flood {
      	if(waterLevel > 0.0)
      	{
      		color <- rgb(0,0,waterLevel*30);
      		isflooded <- true ;
      	} else {
      	//	color <- grid_value = -9999 ? rgb('black') :  rgb(255 * ( grid_value / 100 ), 0, 0) ;
      	}
      }
         
      
   }